#include "annotateLog.h"

void AnnotateLog::Output_GeneInfo(String &genoVCFlog, GeneMap & geneLogMap, String &outGenoVCFlog)
{
  FILE * annotateLogFile = fopen(genoVCFlog,"rt");
	if (annotateLogFile == NULL) {
		error("Error in opening file (%s)\n", genoVCFlog.c_str());
	}
  String geneEntry;
  int indexGeneName = 15, indexChr = 1, indexGeneStart = 7, indexGeneEnd = 8;    
  StringArray tokenLog;
  int fileLen = 0;
	int geneStart, geneEnd;
	std::string chrNum,geneName;
	geneLogMap.clear();
	geneEntry.ReadLine(annotateLogFile); // do not do anything for the header line
	tokenLog.AddTokens(geneEntry, "\t");
	if (tokenLog.Length() < 15) {
		error("Invalid log file (%s)!\n",genoVCFlog.c_str());
	}
	geneEntry.Clear();
	tokenLog.Clear();
  while (!feof(annotateLogFile))
    {
      geneEntry.ReadLine(annotateLogFile);
      if (geneEntry.IsEmpty()){
					continue;
			}
      tokenLog.AddTokens(geneEntry,'\t');
			
      // update the geneLogMap 
      chrNum = tokenLog[indexChr - 1].c_str();
			
			// do this since Yanming's annotation software gives chr# 
			if (chrNum.size() > 3) {
				chrNum = chrNum.substr(3, chrNum.size() - 3);		
			}
			
      geneName = tokenLog[indexGeneName - 1].c_str();
      geneStart = tokenLog[indexGeneStart - 1].AsInteger();
      geneEnd = tokenLog[indexGeneEnd - 1].AsInteger();
      geneLogMap.insert(GeneMap::value_type(StringPair(chrNum,geneName),IntPair(geneStart,geneEnd)));
      //clear the token and entry buffer
      tokenLog.Clear();
      geneEntry.Clear();
      fileLen ++;
    }
  fclose(annotateLogFile);
  // we want to ouput a file with gene names and start,end positions
  FILE * outFile = fopen(outGenoVCFlog,"wt");
  for (GeneMapIterator i = geneLogMap.begin(); i != geneLogMap.end(); i ++)
    {
      fprintf(outFile,"%s\t%s\t%d\t%d\n",i->first.first.c_str(), i->first.second.c_str(), i->second.first, i->second.second);
    } 
  fclose(outFile);
}
